From 07061a79d8c11e364320244bfa91810cbf2c5862 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Fri, 5 Apr 2013 15:20:01 -0400
Subject: [PATCH] Renamed base/deploy to base/server.

The base/deploy folder has been renamed to base/server to match the
package name. The pki.conf has been moved into pki-base package.

Ticket #553, #564
---
 base/CMakeLists.txt                                        |  2 +-
 base/{deploy => server}/CMakeLists.txt                     |  2 +-
 base/{deploy => server}/LICENSE                            |  0
 base/{deploy => server}/config/pkislots.cfg                |  0
 base/{deploy => server}/config/sample.cfg                  |  0
 base/{deploy => server}/config/sampleCAclone.cfg           |  0
 .../config/sampleExternalSignedCA-step1.cfg                |  0
 .../config/sampleExternalSignedCA-step2.cfg                |  0
 base/{deploy => server}/config/sampleKRA.cfg               |  0
 base/{deploy => server}/config/sampleKRAclone.cfg          |  0
 base/{deploy => server}/config/sampleSubordinateCA.cfg     |  0
 base/{deploy => server}/etc/default.cfg                    |  0
 base/{deploy => server}/etc/pki.conf                       |  0
 base/{deploy => server}/man/man5/pki_default.cfg.5         |  0
 base/{deploy => server}/man/man8/pkidestroy.8              |  0
 base/{deploy => server}/man/man8/pkispawn.8                |  0
 base/{deploy => server}/scripts/operations                 |  0
 base/{deploy => server}/scripts/pkidaemon                  |  0
 base/{deploy => server}/src/engine/pkiconfig.py            |  0
 base/{deploy => server}/src/engine/pkihelper.py            |  0
 base/{deploy => server}/src/engine/pkilogging.py           |  0
 base/{deploy => server}/src/engine/pkimanifest.py          |  0
 base/{deploy => server}/src/engine/pkimessages.py          |  0
 base/{deploy => server}/src/engine/pkiparser.py            |  0
 base/{deploy => server}/src/engine/pkiscriptlet.py         |  0
 base/{deploy => server}/src/pkidestroy                     |  0
 base/{deploy => server}/src/pkispawn                       |  0
 base/{deploy => server}/src/scriptlets/configuration.py    |  0
 base/{deploy => server}/src/scriptlets/finalization.py     |  0
 .../src/scriptlets/infrastructure_layout.py                |  0
 base/{deploy => server}/src/scriptlets/initialization.py   |  0
 base/{deploy => server}/src/scriptlets/instance_layout.py  |  0
 .../src/scriptlets/security_databases.py                   |  0
 base/{deploy => server}/src/scriptlets/selinux_setup.py    |  0
 .../{deploy => server}/src/scriptlets/slot_substitution.py |  0
 base/{deploy => server}/src/scriptlets/subsystem_layout.py |  0
 .../{deploy => server}/src/scriptlets/webapp_deployment.py |  0
 scripts/compose_pki_core_packages                          |  2 +-
 specs/pki-core.spec                                        | 14 +++++++++-----
 39 files changed, 12 insertions(+), 8 deletions(-)
 rename base/{deploy => server}/CMakeLists.txt (99%)
 rename base/{deploy => server}/LICENSE (100%)
 rename base/{deploy => server}/config/pkislots.cfg (100%)
 rename base/{deploy => server}/config/sample.cfg (100%)
 rename base/{deploy => server}/config/sampleCAclone.cfg (100%)
 rename base/{deploy => server}/config/sampleExternalSignedCA-step1.cfg (100%)
 rename base/{deploy => server}/config/sampleExternalSignedCA-step2.cfg (100%)
 rename base/{deploy => server}/config/sampleKRA.cfg (100%)
 rename base/{deploy => server}/config/sampleKRAclone.cfg (100%)
 rename base/{deploy => server}/config/sampleSubordinateCA.cfg (100%)
 rename base/{deploy => server}/etc/default.cfg (100%)
 rename base/{deploy => server}/etc/pki.conf (100%)
 rename base/{deploy => server}/man/man5/pki_default.cfg.5 (100%)
 rename base/{deploy => server}/man/man8/pkidestroy.8 (100%)
 rename base/{deploy => server}/man/man8/pkispawn.8 (100%)
 rename base/{deploy => server}/scripts/operations (100%)
 rename base/{deploy => server}/scripts/pkidaemon (100%)
 rename base/{deploy => server}/src/engine/pkiconfig.py (100%)
 rename base/{deploy => server}/src/engine/pkihelper.py (100%)
 rename base/{deploy => server}/src/engine/pkilogging.py (100%)
 rename base/{deploy => server}/src/engine/pkimanifest.py (100%)
 rename base/{deploy => server}/src/engine/pkimessages.py (100%)
 rename base/{deploy => server}/src/engine/pkiparser.py (100%)
 rename base/{deploy => server}/src/engine/pkiscriptlet.py (100%)
 rename base/{deploy => server}/src/pkidestroy (100%)
 rename base/{deploy => server}/src/pkispawn (100%)
 rename base/{deploy => server}/src/scriptlets/configuration.py (100%)
 rename base/{deploy => server}/src/scriptlets/finalization.py (100%)
 rename base/{deploy => server}/src/scriptlets/infrastructure_layout.py (100%)
 rename base/{deploy => server}/src/scriptlets/initialization.py (100%)
 rename base/{deploy => server}/src/scriptlets/instance_layout.py (100%)
 rename base/{deploy => server}/src/scriptlets/security_databases.py (100%)
 rename base/{deploy => server}/src/scriptlets/selinux_setup.py (100%)
 rename base/{deploy => server}/src/scriptlets/slot_substitution.py (100%)
 rename base/{deploy => server}/src/scriptlets/subsystem_layout.py (100%)
 rename base/{deploy => server}/src/scriptlets/webapp_deployment.py (100%)

diff --git a/base/CMakeLists.txt b/base/CMakeLists.txt
index f646cfb608dc03e4b3ac0162cba41837179ad4a5..0a8e5164754c18f77c2c9ecc8f17508c38fffb23 100644
--- a/base/CMakeLists.txt
+++ b/base/CMakeLists.txt
@@ -9,7 +9,7 @@ if (APPLICATION_FLAVOR_PKI_CORE)
     add_subdirectory(common)
     add_subdirectory(native-tools)
     add_subdirectory(java-tools)
-    add_subdirectory(deploy)
+    add_subdirectory(server)
     if(BUILD_PKI_SELINUX)
         add_subdirectory(selinux)
     endif(BUILD_PKI_SELINUX)
diff --git a/base/deploy/CMakeLists.txt b/base/server/CMakeLists.txt
similarity index 99%
rename from base/deploy/CMakeLists.txt
rename to base/server/CMakeLists.txt
index 9c2b7f9425dd85990825cc114ecc2141daf1d1f2..1f638dc95ce308d39276414356b069fede07b23a 100644
--- a/base/deploy/CMakeLists.txt
+++ b/base/server/CMakeLists.txt
@@ -1,4 +1,4 @@
-project(deploy)
+project(server)
 
 set(PKI_SUBSYSTEMS
     ca
diff --git a/base/deploy/LICENSE b/base/server/LICENSE
similarity index 100%
rename from base/deploy/LICENSE
rename to base/server/LICENSE
diff --git a/base/deploy/config/pkislots.cfg b/base/server/config/pkislots.cfg
similarity index 100%
rename from base/deploy/config/pkislots.cfg
rename to base/server/config/pkislots.cfg
diff --git a/base/deploy/config/sample.cfg b/base/server/config/sample.cfg
similarity index 100%
rename from base/deploy/config/sample.cfg
rename to base/server/config/sample.cfg
diff --git a/base/deploy/config/sampleCAclone.cfg b/base/server/config/sampleCAclone.cfg
similarity index 100%
rename from base/deploy/config/sampleCAclone.cfg
rename to base/server/config/sampleCAclone.cfg
diff --git a/base/deploy/config/sampleExternalSignedCA-step1.cfg b/base/server/config/sampleExternalSignedCA-step1.cfg
similarity index 100%
rename from base/deploy/config/sampleExternalSignedCA-step1.cfg
rename to base/server/config/sampleExternalSignedCA-step1.cfg
diff --git a/base/deploy/config/sampleExternalSignedCA-step2.cfg b/base/server/config/sampleExternalSignedCA-step2.cfg
similarity index 100%
rename from base/deploy/config/sampleExternalSignedCA-step2.cfg
rename to base/server/config/sampleExternalSignedCA-step2.cfg
diff --git a/base/deploy/config/sampleKRA.cfg b/base/server/config/sampleKRA.cfg
similarity index 100%
rename from base/deploy/config/sampleKRA.cfg
rename to base/server/config/sampleKRA.cfg
diff --git a/base/deploy/config/sampleKRAclone.cfg b/base/server/config/sampleKRAclone.cfg
similarity index 100%
rename from base/deploy/config/sampleKRAclone.cfg
rename to base/server/config/sampleKRAclone.cfg
diff --git a/base/deploy/config/sampleSubordinateCA.cfg b/base/server/config/sampleSubordinateCA.cfg
similarity index 100%
rename from base/deploy/config/sampleSubordinateCA.cfg
rename to base/server/config/sampleSubordinateCA.cfg
diff --git a/base/deploy/etc/default.cfg b/base/server/etc/default.cfg
similarity index 100%
rename from base/deploy/etc/default.cfg
rename to base/server/etc/default.cfg
diff --git a/base/deploy/etc/pki.conf b/base/server/etc/pki.conf
similarity index 100%
rename from base/deploy/etc/pki.conf
rename to base/server/etc/pki.conf
diff --git a/base/deploy/man/man5/pki_default.cfg.5 b/base/server/man/man5/pki_default.cfg.5
similarity index 100%
rename from base/deploy/man/man5/pki_default.cfg.5
rename to base/server/man/man5/pki_default.cfg.5
diff --git a/base/deploy/man/man8/pkidestroy.8 b/base/server/man/man8/pkidestroy.8
similarity index 100%
rename from base/deploy/man/man8/pkidestroy.8
rename to base/server/man/man8/pkidestroy.8
diff --git a/base/deploy/man/man8/pkispawn.8 b/base/server/man/man8/pkispawn.8
similarity index 100%
rename from base/deploy/man/man8/pkispawn.8
rename to base/server/man/man8/pkispawn.8
diff --git a/base/deploy/scripts/operations b/base/server/scripts/operations
similarity index 100%
rename from base/deploy/scripts/operations
rename to base/server/scripts/operations
diff --git a/base/deploy/scripts/pkidaemon b/base/server/scripts/pkidaemon
similarity index 100%
rename from base/deploy/scripts/pkidaemon
rename to base/server/scripts/pkidaemon
diff --git a/base/deploy/src/engine/pkiconfig.py b/base/server/src/engine/pkiconfig.py
similarity index 100%
rename from base/deploy/src/engine/pkiconfig.py
rename to base/server/src/engine/pkiconfig.py
diff --git a/base/deploy/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
similarity index 100%
rename from base/deploy/src/engine/pkihelper.py
rename to base/server/src/engine/pkihelper.py
diff --git a/base/deploy/src/engine/pkilogging.py b/base/server/src/engine/pkilogging.py
similarity index 100%
rename from base/deploy/src/engine/pkilogging.py
rename to base/server/src/engine/pkilogging.py
diff --git a/base/deploy/src/engine/pkimanifest.py b/base/server/src/engine/pkimanifest.py
similarity index 100%
rename from base/deploy/src/engine/pkimanifest.py
rename to base/server/src/engine/pkimanifest.py
diff --git a/base/deploy/src/engine/pkimessages.py b/base/server/src/engine/pkimessages.py
similarity index 100%
rename from base/deploy/src/engine/pkimessages.py
rename to base/server/src/engine/pkimessages.py
diff --git a/base/deploy/src/engine/pkiparser.py b/base/server/src/engine/pkiparser.py
similarity index 100%
rename from base/deploy/src/engine/pkiparser.py
rename to base/server/src/engine/pkiparser.py
diff --git a/base/deploy/src/engine/pkiscriptlet.py b/base/server/src/engine/pkiscriptlet.py
similarity index 100%
rename from base/deploy/src/engine/pkiscriptlet.py
rename to base/server/src/engine/pkiscriptlet.py
diff --git a/base/deploy/src/pkidestroy b/base/server/src/pkidestroy
similarity index 100%
rename from base/deploy/src/pkidestroy
rename to base/server/src/pkidestroy
diff --git a/base/deploy/src/pkispawn b/base/server/src/pkispawn
similarity index 100%
rename from base/deploy/src/pkispawn
rename to base/server/src/pkispawn
diff --git a/base/deploy/src/scriptlets/configuration.py b/base/server/src/scriptlets/configuration.py
similarity index 100%
rename from base/deploy/src/scriptlets/configuration.py
rename to base/server/src/scriptlets/configuration.py
diff --git a/base/deploy/src/scriptlets/finalization.py b/base/server/src/scriptlets/finalization.py
similarity index 100%
rename from base/deploy/src/scriptlets/finalization.py
rename to base/server/src/scriptlets/finalization.py
diff --git a/base/deploy/src/scriptlets/infrastructure_layout.py b/base/server/src/scriptlets/infrastructure_layout.py
similarity index 100%
rename from base/deploy/src/scriptlets/infrastructure_layout.py
rename to base/server/src/scriptlets/infrastructure_layout.py
diff --git a/base/deploy/src/scriptlets/initialization.py b/base/server/src/scriptlets/initialization.py
similarity index 100%
rename from base/deploy/src/scriptlets/initialization.py
rename to base/server/src/scriptlets/initialization.py
diff --git a/base/deploy/src/scriptlets/instance_layout.py b/base/server/src/scriptlets/instance_layout.py
similarity index 100%
rename from base/deploy/src/scriptlets/instance_layout.py
rename to base/server/src/scriptlets/instance_layout.py
diff --git a/base/deploy/src/scriptlets/security_databases.py b/base/server/src/scriptlets/security_databases.py
similarity index 100%
rename from base/deploy/src/scriptlets/security_databases.py
rename to base/server/src/scriptlets/security_databases.py
diff --git a/base/deploy/src/scriptlets/selinux_setup.py b/base/server/src/scriptlets/selinux_setup.py
similarity index 100%
rename from base/deploy/src/scriptlets/selinux_setup.py
rename to base/server/src/scriptlets/selinux_setup.py
diff --git a/base/deploy/src/scriptlets/slot_substitution.py b/base/server/src/scriptlets/slot_substitution.py
similarity index 100%
rename from base/deploy/src/scriptlets/slot_substitution.py
rename to base/server/src/scriptlets/slot_substitution.py
diff --git a/base/deploy/src/scriptlets/subsystem_layout.py b/base/server/src/scriptlets/subsystem_layout.py
similarity index 100%
rename from base/deploy/src/scriptlets/subsystem_layout.py
rename to base/server/src/scriptlets/subsystem_layout.py
diff --git a/base/deploy/src/scriptlets/webapp_deployment.py b/base/server/src/scriptlets/webapp_deployment.py
similarity index 100%
rename from base/deploy/src/scriptlets/webapp_deployment.py
rename to base/server/src/scriptlets/webapp_deployment.py
diff --git a/scripts/compose_pki_core_packages b/scripts/compose_pki_core_packages
index 74e872589a89bbe78c3781d024d9e3c0653e481a..76a77043008b63db54cb9314aa6bc9ad75824ced 100755
--- a/scripts/compose_pki_core_packages
+++ b/scripts/compose_pki_core_packages
@@ -39,7 +39,7 @@ PKI_CORE_VERSION="10.0.1"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_CORE}.spec"
-PKI_COMPONENT_LIST="test setup symkey util common native-tools java-tools deploy selinux ca kra ocsp tks silent"
+PKI_COMPONENT_LIST="test setup symkey util common native-tools java-tools server selinux ca kra ocsp tks silent"
 
 if [ "$JAVADOC" = "" ]; then
     PKI_COMPONENT_LIST="$PKI_COMPONENT_LIST javadoc"
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 4bd4f0100ae90c055af758a0c338e58cad1bad5e..73c374d8e04af269fcf67e6b2131ba28f15675fe 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -5,7 +5,7 @@ distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
 Version:          10.0.1
-Release:          8%{?dist}
+Release:          9%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -810,6 +810,8 @@ fi
 %doc base/common/LICENSE
 %dir %{_datadir}/pki
 %{_datadir}/pki/VERSION
+%dir %{_sysconfdir}/pki
+%config(noreplace) %{_sysconfdir}/pki/pki.conf
 %dir %{_javadir}/pki
 %{_javadir}/pki/pki-cmsutil.jar
 %{_javadir}/pki/pki-nsutil.jar
@@ -857,9 +859,7 @@ fi
 %files -n pki-server
 %defattr(-,root,root,-)
 %doc base/common/THIRD_PARTY_LICENSES
-%doc base/deploy/LICENSE
-%dir %{_sysconfdir}/pki/
-%config(noreplace) %{_sysconfdir}/pki/pki.conf
+%doc base/server/LICENSE
 %{_sysconfdir}/pki/default.cfg
 %{_sbindir}/pkispawn
 %{_sbindir}/pkidestroy
@@ -902,7 +902,6 @@ fi
 %config(noreplace) %{_sysconfdir}/tmpfiles.d/pki-tomcat.conf
 
 %{_datadir}/pki/setup/
-%dir %{_datadir}/pki/server
 %{_datadir}/pki/server/
 
 %if ! 0%{?rhel} && 0%{?fedora} <= 17
@@ -1007,6 +1006,11 @@ fi
 
 
 %changelog
+* Fri Apr 5 2013 Endi S. Dewata <edewata@redhat.com> 10.0.1-9
+- Renamed base/deploy to base/server.
+- Moved pki.conf into pki-base.
+- Removed redundant pki/server folder declaration.
+
 * Tue Mar 19 2013 Ade Lee <alee@redhat.com> 10.0.1-8
 - Removed jython dependency
 
-- 
1.8.1.4